﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using Infragistics.Web.UI.NavigationControls;
using Infragistics.Web.UI;
using System.Collections;

public partial class _Default : System.Web.UI.Page
{
    //  Variable to check if the ItemClick event fired earlier.
    bool _bDidClickEvent = false;

    class ButtonTemplate : ITemplate
    {
        public void InstantiateIn(Control container)
        {
            String name = container.GetType().ToString();
            Button btn = new Button();
            btn.Text = "My Button";
            btn.ID = "tmplbtn1";
            container.Controls.Add(btn);
        }
    }

    protected void Page_Load(object sender, EventArgs e)
    {
        if (!Page.IsPostBack)
        {
            for (int i = 0; i < 5; ++i)
            {
                //  Create the menu items and add them to the menu.
                DataMenuItem dmi = new DataMenuItem();
                WebDataMenu1.Items.Add(dmi);
            }
        }

        //  Templates aren't saved in view state, so they must be recreated after postback.
        ButtonTemplate btmp = new ButtonTemplate();

        for (int i = 0; i < 5; ++i)
        {
            DataMenuItem dmi = WebDataMenu1.Items[i];
            dmi.Template = btmp;
        }
    }

    protected void Page_PreRenderComplete(object sender, EventArgs e)
    {
        if (_bDidClickEvent)
        {
            Button btn = (Button)WebDataMenu1.Items[0].FindControl("tmplbtn1");
        }
    }

    protected void WebDataMenu1_ItemClick(object sender, DataMenuItemEventArgs e)
    {
        //  Set the variable.
        _bDidClickEvent = true;
    }
}